unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Types;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    Image1: TImage;
    RadioGroup2: TRadioGroup;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    // g\p
    Deplacement : Boolean;
    Origine, Move : TPoint;
    // }W
    au, ao: double;                 // X 
    bo, bu: Double;                 // y 
   //--------------------
    OutputBitmap  : TBitmap;    // }prbg}bv
    DREWF         : Boolean;        // }ς݃tO
    procedure initial_value;
    procedure DrawMandelbrot(Aimage: Timage; X, Y, au, bu: Double; X2, Y2, item, md: Integer);
    procedure Zoom(Lz, Rz, Lt: integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TPrgbarry = array[0..0] of Trgbtriple;  // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                 // |C^[

// -------------- Mandelbrot } ------------------------
// Aimage  : Timage
// X, Y    : xy1hbgω
// au, bu  : xy}Wl
// X2, Y2  : `TCYX, Y
// item    : FI
// md      : }J[[h
procedure TForm1.DrawMandelbrot(Aimage: Timage; X, Y, au, bu: Double; X2, Y2, item, md: Integer);
var
  a, b, Xn, Yn, tmp : Double;
  i, j, Count       : Integer;
  col               : byte;
  PBA               : Prgbarray;            // RGBtriplez̃|C^[
begin
  col := 0;
  b := bu;
  for i := 0 to Y2 - 1 do
  begin
    PBA := OutputBitmap.ScanLine[i];
    a := au;
    for j := 0 to X2 - 1 do
    begin
      Xn := 0;
      Yn := 0;
      count := 0;
      while Xn * Xn + Yn * Yn < 4 do
      begin
        tmp := Xn;
        Xn := Xn * Xn - Yn * Yn + a;
        Yn := 2 * tmp * Yn + b;
        Inc(count);
        case md of
          0: if count = 60 then break;
          1: if count = 256 then break;
          2: if count = 255 then break;
        end;
      end;
      case md of
        0: col := 16 * Count mod 256;
        1: col := count;
        2: col := count;
      end;
      case item of
        0 : begin PBA[j].rgbtRed := col; PBA[j].rgbtGreen := 0; PBA[j].rgbtBlue := 0; end;                 // 
        1 : begin PBA[j].rgbtRed := 0; PBA[j].rgbtGreen := col; PBA[j].rgbtBlue := 0; end;                 // 
        2 : begin PBA[j].rgbtRed := col div 2; PBA[j].rgbtGreen := col div 2; PBA[j].rgbtBlue := col; end; // 
        3 : begin PBA[j].rgbtRed := col; PBA[j].rgbtGreen := 0; PBA[j].rgbtBlue := col; end;               // 
        4 : begin PBA[j].rgbtRed := col; PBA[j].rgbtGreen := col; PBA[j].rgbtBlue := 0; end;               // 
        5 : begin PBA[j].rgbtRed := col; PBA[j].rgbtGreen := col; PBA[j].rgbtBlue := col; end;             // D
      end;
      a := a + X;
    end;
    b := b + Y;
  end;
  Aimage.Picture.Bitmap := OutputBitmap;
end;

// l
procedure TForm1.initial_value;
begin
  ao := 0.7;                            // Xl
  au := -2;                             // XŏIl
  bo := 1.5;                            // Yl
  bu := -1.5;                           // YŏIl
end;

// }
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  dX, dY: Double;
  item, md : integer;
begin
  // Initialize Mandelbrot
  item := RadioGroup1.ItemIndex;        // F̑I
  md := RadioGroup2.ItemIndex;          // Fp^[̑I
  initial_value;
  // direct scaling cause of speed
  dX := (ao - au) / Image1.Width;       // X1hbgω
  dY := (bo - bu) / Image1.Height;      // y1hbgω
  DrawMandelbrot(Image1, dX, dY, au, bu, Image1.Width, Image1.Height, item, md);
  DREWF := True;
end;

// 摜NA
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  initial_value;
  Image1.Canvas.Brush.Color := clbtnface;
  Image1.Canvas.FillRect(Canvas.ClipRect);
  DREWF := False;
end;

// I rbg}bv
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OutputBitmap.Free;      // bitmap̊J
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  DREWF := False;                           // }ς݃tO
  Image1.Width := Bitbtn1.Left - 30;
  OutputBitmap := TBitmap.Create;
  OutputBitmap.PixelFormat := pf24bit;
  OutputBitmap.Height := Image1.Height;
  OutputBitmap.Width := Image1.Width;
end;

// --------͈͎wg\ǉ ------------------------------------------------
// Lz ͈͍W
// Rz ͈͉EW
// Lt ͈͏W
procedure TForm1.Zoom(Lz, Rz, Lt: integer);
var
  dX, dY : Double;
  item, md : integer;
  Wz, Hz : integer;
begin
  item := RadioGroup1.ItemIndex;            // F̑I
  md := RadioGroup2.ItemIndex;              // Fp^[̑I
  Wz := Image1.Width;
  Hz := Image1.Height;
  dX := (ao - au) / Wz * (Rz - Lz) / Wz;    // X1hbgω
  dY := (bo - bu) / Hz * (Rz - Lz) / Wz;    // Y1hbgω
  au := (ao - au) / Wz  * Lz + au;          // Xl
  bu := (bo - bu) / Hz * Lt + bu;           // XŏIl
  ao := au + Dx *  Wz;                      // Yl
  bo := bu + Dy *  Hz;                      // YŏIl

  DrawMandelbrot(Image1, dX, dY, au, bu, Wz, Hz, item, md);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not DREWF then exit;;
  Deplacement := True;
  Origine := Point(X, Y);
	Move := Origine;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
	Rapport : Double;
begin
  if not DREWF then exit;;
	if Deplacement then
  begin
    Rapport := Image1.Height / Image1.Width;
    Canvas.Pen.Style := psDot;
    Canvas.Pen.Mode := pmNotXor;
    Canvas.Rectangle(Origine.x, Origine.y, Move.x, Origine.y + Round((Move.x-Origine.x)*Rapport));
    Move := Point(X, Y);
    Canvas.Rectangle(Origine.x, Origine.y, Move.x, Origine.y + Round((Move.x-Origine.x)*Rapport));
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not DREWF then exit;;
  Canvas.Pen.Mode := pmCopy;
  Deplacement := False;
  if (Origine.X - X >= 0) or (Origine.Y - Y >= 0) then
  begin
    BitBtn1Click(nil);
  end
  else begin
    Zoom(Origine.X, X, Origine.Y);
  end;
end;

end.
